//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ライタヘッダ
 * @author Junpee
 */

#ifndef WRITER_H_
#define WRITER_H_

#include <Core/InputOutput/OutputStream.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * ライタ
 *
 * データ書き出しのインターフェース
 */
class Writer{
public:
	/**
	 * バイトデータの書き出し
	 * @param data 書き出すバイトデータ
	 * @param size 書き出すサイズ
	 */
	void writeBytes(const void* data, int size){
		Assert(stream_ != NULL);
		stream_->writeBytes(data, size);
	}

	/**
	 * サイズの取得
	 * @return 書き込んだバイト数
	 */
	int getSize(){
		Assert(stream_ != NULL);
		return stream_->getSize();
	}

	/**
	 * スキップ
	 *
	 * 指定されたバイト数、0を書き出します。
	 * @param size 0を書き出すバイト数
	 */
	void skip(int size){
		Assert(stream_ != NULL);
		stream_->skip(size);
	}

	/**
	 * アライメントを取る
	 *
	 * 指定されたバイト数のアライメントまで0を書き出します。
	 * @param size アライメントをとるバイト数
	 * @return 0を書き出したバイト数
	 */
	int align(int size){
		Assert(stream_ != NULL);
		return stream_->align(size);
	}

	/**
	 * フラッシュ
	 *
	 * ストリームをフラッシュします。
	 */
	void flush(){
		Assert(stream_ != NULL);
		stream_->flush();
	}

	/**
	 * 書き込み位置の取得
	 * @return 書き込み位置
	 */
	int getPosition(){
		Assert(stream_ != NULL);
		return stream_->getPosition();
	}

	/**
	 * 書き込み位置の設定
	 *
	 * 指定された位置に書き込み位置を変更します。
	 * @param position 書き込み位置
	 */
	void setPosition(int position){
		Assert(stream_ != NULL);
		stream_->setPosition(position);
	}

protected:
	/**
	 * コンストラクタ
	 */
	Writer(){ stream_ = NULL; }

	/**
	 * デストラクタ
	 */
	virtual ~Writer(){
		Assert(stream_ != NULL);
		delete stream_;
		stream_ = NULL;
	}

	/// 出力ストリーム
	OutputStream* stream_;

private:
	// コピーコンストラクタの隠蔽
	Writer(const Writer& copy);

	// 代入コピーの隠蔽
	void operator =(const Writer& copy);

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of WRITER_H_
//------------------------------------------------------------------------------
